import { ChangeDetectionStrategy, ChangeDetectorRef, Component, ContentChild, Directive, ElementRef, EventEmitter, HostBinding, HostListener, Injectable, Input, NgModule, Output, Renderer2, TemplateRef, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { LoaderModule, LoaderService } from 'meepo-loader';
import { Subject as Subject$1 } from 'rxjs/Subject';
import { EventModule } from 'meepo-event';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperConfig {
    constructor() {
        this.options = {};
    }
}
SwiperConfig.decorators = [
    { type: Injectable },
];
/** @nocollapse */
SwiperConfig.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperComponent {
    /**
     * @param {?} el
     * @param {?} DEF
     * @param {?} loader
     * @param {?} render
     * @param {?} cd
     */
    constructor(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this.items = [];
        // 监听改变
        this.slideChange = new EventEmitter();
        this.slideChangeTransitionStart = new EventEmitter();
        this.slideChangeTransitionEnd = new EventEmitter();
        this.sliderMove = new EventEmitter();
        this.reachBeginning = new EventEmitter();
        this.reachEnd = new EventEmitter();
        this.slideNextTransitionStart = new EventEmitter();
        this.slideNextTransitionEnd = new EventEmitter();
        this.slidePrevTransitionStart = new EventEmitter();
        this.slidePrevTransitionEnd = new EventEmitter();
        this.init = new EventEmitter();
        this.onClick = new EventEmitter();
        this.onTap = new EventEmitter();
        this.doubleTap = new EventEmitter();
        this.progress = new EventEmitter();
        this.touchStart = new EventEmitter();
        this.touchMove = new EventEmitter();
        this.touchEnd = new EventEmitter();
        this.realIndex = new EventEmitter();
        this.down = new EventEmitter();
        this.up = new EventEmitter();
        this.auto = true;
        this.down$ = new Subject$1();
        this.up$ = new Subject$1();
        this.isDown = '';
        this.down$.subscribe(res => {
            this.refresh.html('加载完毕');
            setTimeout(() => {
                this.swiper.touchEventsData.isTouched = true;
                this.swiper.allowTouchMove = true;
                this.swiper.params.virtualTranslate = false;
                this.swiper.setTranslate(0);
            }, 600);
        });
        this.up$.subscribe(res => {
            this.loadmore.html('加载完毕');
            setTimeout(() => {
                this.swiper.allowTouchMove = true;
                this.swiper.params.virtualTranslate = false;
                this.swiper.setTranslate(0);
            }, 600);
        });
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set options(val) {
        this._options = val;
        if (this._options.direction === 'vertical') {
            this.vertical = 'vertical';
        }
        else {
            this.horizontal = 'horizontal';
        }
    }
    /**
     * @return {?}
     */
    get options() {
        return this._options;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set horizontal(val) {
        this.render.removeClass(this.el.nativeElement, 'swiper-container-vertical');
        this.render.addClass(this.el.nativeElement, 'swiper-container-horizontal');
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set vertical(val) {
        this.render.removeClass(this.el.nativeElement, 'swiper-container-horizontal');
        this.render.addClass(this.el.nativeElement, 'swiper-container-vertical');
    }
    /**
     * @return {?}
     */
    initOptions() {
        this.options = Object.assign({}, this.DEF.options, this.options);
    }
    /**
     * @param {?} index
     * @param {?=} slideToOption
     * @return {?}
     */
    slideTo(index, slideToOption) {
        this.slideToOption = slideToOption;
        if (index < 0) { }
        else {
            this.swiper.slideTo(index, 600, false);
        }
    }
    /**
     * @param {?=} reinit
     * @return {?}
     */
    _init(reinit = false) {
        let /** @type {?} */ that = this;
        if (this.auto || reinit) {
            this.destroy();
            this.options = Object.assign({
                speed: 300,
                slidesPerView: 'auto',
                freeMode: true,
                direction: 'vertical',
                setWrapperSize: true,
                scrollbar: {
                    el: '.swiper-scrollbar',
                },
                on: {
                    slideChange: () => {
                        this.slideChange.emit(this.swiper);
                    },
                    slideChangeTransitionStart: () => {
                        this.slideChangeTransitionStart.emit(this.swiper);
                    },
                    slideChangeTransitionEnd: () => {
                        this.slideChangeTransitionEnd.emit(this.swiper);
                    },
                    sliderMove: () => {
                        this.sliderMove.emit(this.swiper);
                    },
                    reachBeginning: () => {
                        this.reachBeginning.emit(this.swiper);
                    },
                    reachEnd: () => {
                        this.reachEnd.emit(this.swiper);
                    },
                    slideNextTransitionStart: () => {
                        this.slideNextTransitionStart.emit(this.swiper);
                    },
                    slideNextTransitionEnd: () => {
                        this.slideNextTransitionEnd.emit(this.swiper);
                    },
                    slidePrevTransitionStart: () => {
                        this.slidePrevTransitionStart.emit(this.swiper);
                    },
                    slidePrevTransitionEnd: () => {
                        this.slidePrevTransitionEnd.emit(this.swiper);
                    },
                    init: () => {
                        this.init.emit(this.swiper);
                    },
                    click: () => {
                        this.onClick.emit(this.swiper);
                    },
                    tap: () => {
                        this.onTap.emit(this.swiper);
                    },
                    doubleTap: () => {
                        this.doubleTap.emit(this.swiper);
                    },
                    progress: () => {
                        this.progress.emit(this.swiper);
                    },
                    touchStart: () => {
                        this.touchStart.emit(this.swiper);
                    },
                    touchMove: function () {
                        that.touchMove.emit(this.swiper);
                    },
                    touchEnd: () => {
                        if (this.isDown === 'down') {
                            this.refresh.html('<i class="weui-loading"></i>刷新中...');
                            this.down.emit(this.down$);
                        }
                        if (this.isDown === 'up') {
                            this.loadmore.html('<i class="weui-loading"></i>加载中...');
                            this.up.emit(this.up$);
                        }
                        this.touchEnd.emit(that.swiper);
                    },
                    momentumBounce: function () {
                        this.allowTouchMove = true;
                        this.params.virtualTranslate = false;
                    }
                }
            }, this.options);
            this.swiper = new Swiper(this.el.nativeElement, this.options);
            this.init.next(this.swiper);
        }
    }
    /**
     * @return {?}
     */
    destroy() {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.options)
            this.initOptions();
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.__init();
    }
    /**
     * @return {?}
     */
    __init() {
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(res => {
                this._init();
            });
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this._init();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
SwiperComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper',
                template: `<div class="swiper-wrapper">
    <div class="swiper-slide" [attr.data-hash]="item.link" *ngFor="let item of items">
        <ng-container *ngTemplateOutlet="_ref;context: {$implicit: item}"></ng-container>
    </div>
</div>
<ng-content></ng-content>`,
                styles: [``],
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
            },] },
];
/** @nocollapse */
SwiperComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: SwiperConfig, },
    { type: LoaderService, },
    { type: Renderer2, },
    { type: ChangeDetectorRef, },
];
SwiperComponent.propDecorators = {
    "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
    "_ref": [{ type: ContentChild, args: [TemplateRef,] },],
    "options": [{ type: Input },],
    "horizontal": [{ type: Input },],
    "vertical": [{ type: Input },],
    "items": [{ type: Input },],
    "slideChange": [{ type: Output },],
    "slideChangeTransitionStart": [{ type: Output },],
    "slideChangeTransitionEnd": [{ type: Output },],
    "sliderMove": [{ type: Output },],
    "reachBeginning": [{ type: Output },],
    "reachEnd": [{ type: Output },],
    "slideNextTransitionStart": [{ type: Output },],
    "slideNextTransitionEnd": [{ type: Output },],
    "slidePrevTransitionStart": [{ type: Output },],
    "slidePrevTransitionEnd": [{ type: Output },],
    "init": [{ type: Output },],
    "onClick": [{ type: Output },],
    "onTap": [{ type: Output },],
    "doubleTap": [{ type: Output },],
    "progress": [{ type: Output },],
    "touchStart": [{ type: Output },],
    "touchMove": [{ type: Output },],
    "touchEnd": [{ type: Output },],
    "realIndex": [{ type: Output },],
    "down": [{ type: Output },],
    "up": [{ type: Output },],
    "auto": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperTabsComponent {
    constructor() {
        this.tabs = [];
        this.footerOptions = {
            loop: false,
            preventLinksPropagation: true,
            controller: {
                control: [],
                inverse: true,
                by: 'slide',
            },
            initialSlide: 0,
            centeredSlides: true
        };
        this.mainOptions = {
            loop: false,
            controller: {
                control: [],
                inverse: true,
                by: 'slide',
            }
        };
        this.from = 'footer';
    }
    /**
     * @return {?}
     */
    ngOnInit() { }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        let /** @type {?} */ height = this.header.nativeElement.clientHeight;
        this.mainHeight = `calc( 100% - ${height}px)`;
    }
    /**
     * @param {?} e
     * @return {?}
     */
    initMain(e) {
        if (e) {
            this.mainCtrl = e;
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    initFooter(e) {
        if (e) {
            this.footerCtrl = e;
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    touchStartFooter(e) {
        this.from = 'footer';
    }
    /**
     * @param {?} e
     * @return {?}
     */
    touchStartMain(e) {
        this.from = 'main';
    }
    /**
     * @param {?} e
     * @return {?}
     */
    doFooterItem(e) {
        if (e) {
            if (this.from === 'footer') {
                this.mainCtrl.slideTo(e.activeIndex);
            }
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    doMainItem(e) {
        if (e) {
            if (this.from === 'main') {
                this.footerCtrl.slideTo(e.activeIndex);
            }
        }
    }
}
SwiperTabsComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper-tabs',
                template: `<div #header class="header-advs">
    <div class="header-navs">
        <div class="header-navs-item">
            <span>全部</span>
        </div>
        <swiper [items]="tabs" (init)="initFooter($event)" (touchStart)="touchStartFooter($event)" (slideChange)="doFooterItem($event)"
            [options]="footerOptions">
            <ng-template let-item>
                <p>{{item.title}}</p>
            </ng-template>
        </swiper>
        <div class="header-navs-content"></div>
    </div>
</div>
<div class="main" [style.height]="mainHeight">
    <swiper [items]="tabs" [options]="mainOptions" (touchStart)="touchStartMain($event)" (init)="initMain($event)" (slideChange)="doMainItem($event)">
        <ng-template let-item>
            <ng-container *ngTemplateOutlet="_ref;context: {$implicit: item}"></ng-container>
        </ng-template>
    </swiper>
</div>
`,
                styles: [``],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
SwiperTabsComponent.ctorParameters = () => [];
SwiperTabsComponent.propDecorators = {
    "header": [{ type: ViewChild, args: ['header',] },],
    "_ref": [{ type: ContentChild, args: [TemplateRef,] },],
    "tabs": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperMenuCenterDirective {
    constructor() {
        this._slide = true;
        this.click$ = new Subject$1();
    }
    /**
     * @return {?}
     */
    onClick() {
        this.click$.next();
    }
    /**
     * @param {?} call
     * @return {?}
     */
    clickBack(call) {
        return this.click$.subscribe(res => {
            call(res);
        });
    }
}
SwiperMenuCenterDirective.decorators = [
    { type: Directive, args: [{ selector: '[swiperCenter]' },] },
];
/** @nocollapse */
SwiperMenuCenterDirective.ctorParameters = () => [];
SwiperMenuCenterDirective.propDecorators = {
    "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
    "onClick": [{ type: HostListener, args: ['click', ['$event'],] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperMenuLeftDirective {
    /**
     * @param {?} ele
     * @param {?} render
     */
    constructor(ele, render) {
        this.ele = ele;
        this.render = render;
        this._slide = true;
    }
    /**
     * @return {?}
     */
    show() {
        this.render.addClass(this.ele.nativeElement, 'shown');
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    }
    /**
     * @param {?} val
     * @return {?}
     */
    setWidth(val) {
        this.render.setStyle(this.ele.nativeElement, 'width', val);
    }
}
SwiperMenuLeftDirective.decorators = [
    { type: Directive, args: [{ selector: '[swiperLeft]' },] },
];
/** @nocollapse */
SwiperMenuLeftDirective.ctorParameters = () => [
    { type: ElementRef, },
    { type: Renderer2, },
];
SwiperMenuLeftDirective.propDecorators = {
    "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperMenuRightDirective {
    /**
     * @param {?} ele
     * @param {?} render
     */
    constructor(ele, render) {
        this.ele = ele;
        this.render = render;
        this._slide = true;
    }
    /**
     * @return {?}
     */
    show() {
        this.render.addClass(this.ele.nativeElement, 'shown');
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    }
    /**
     * @param {?} val
     * @return {?}
     */
    setWidth(val) {
        this.render.setStyle(this.ele.nativeElement, 'width', val);
    }
}
SwiperMenuRightDirective.decorators = [
    { type: Directive, args: [{ selector: '[swiperRight]' },] },
];
/** @nocollapse */
SwiperMenuRightDirective.ctorParameters = () => [
    { type: ElementRef, },
    { type: Renderer2, },
];
SwiperMenuRightDirective.propDecorators = {
    "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperHComponent {
    /**
     * @param {?} el
     * @param {?} DEF
     * @param {?} loader
     * @param {?} render
     * @param {?} cd
     */
    constructor(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._horizontal = true;
        this.init = new EventEmitter();
        this.slideChange = new EventEmitter();
        this.onEnd = new EventEmitter();
        this.slideIndex = 0;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set offset(val) {
        if (typeof val === 'string') {
            val = parseInt(val);
        }
        if (typeof val === 'number') {
            val = `${val}px`;
            this.left && this.left.setWidth(val);
            this.right && this.right.setWidth(val);
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set width(val) {
        this.left && this.left.setWidth(val);
        this.right && this.right.setWidth(val);
    }
    /**
     * @return {?}
     */
    initOptions() {
        this.options = Object.assign({}, this.DEF.options, this.options);
    }
    /**
     * @param {?} index
     * @return {?}
     */
    slideTo(index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    }
    /**
     * @return {?}
     */
    getSlideIndex() {
        if (this.left) {
            this.slideIndex = 1;
        }
    }
    /**
     * @return {?}
     */
    _init() {
        this.destroy();
        this.getSlideIndex();
        this.options = Object.assign({
            initialSlide: 1,
            slidesPerView: 'auto',
            resistanceRatio: 0,
            slideToClickedSlide: true,
            loop: false,
            observer: true,
            observeParents: true,
            on: {
                init: () => {
                    this.left && this.left.show();
                    this.right && this.right.show();
                },
                transitionEnd: () => {
                    this.slideChange.emit(this.swiper);
                    this.onEnd.emit(this.swiper);
                }
            }
        }, this.options);
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
    }
    /**
     * @return {?}
     */
    destroy() {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.options)
            this.initOptions();
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.__init();
        if (this.center) {
            this.center.clickBack(res => {
                this.swiper.slideTo(this.slideIndex, 300);
            });
        }
    }
    /**
     * @return {?}
     */
    __init() {
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(res => {
                this._init();
            });
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this.__init();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
SwiperHComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper-h',
                template: `<div class="swiper-wrapper">
    <ng-content></ng-content>
</div>`,
                styles: [``],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
SwiperHComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: SwiperConfig, },
    { type: LoaderService, },
    { type: Renderer2, },
    { type: ChangeDetectorRef, },
];
SwiperHComponent.propDecorators = {
    "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
    "_horizontal": [{ type: HostBinding, args: ['class.swiper-container-horizontal',] },],
    "center": [{ type: ContentChild, args: [SwiperMenuCenterDirective,] },],
    "left": [{ type: ContentChild, args: [SwiperMenuLeftDirective,] },],
    "right": [{ type: ContentChild, args: [SwiperMenuRightDirective,] },],
    "offset": [{ type: Input },],
    "width": [{ type: Input },],
    "options": [{ type: Input },],
    "init": [{ type: Output },],
    "slideChange": [{ type: Output },],
    "onEnd": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperBodyDirective {
    /**
     * @param {?} render
     * @param {?} ele
     */
    constructor(render, ele) {
        this.render = render;
        this.ele = ele;
        this._slide = true;
    }
    /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    setHeight(val, absolute = false) {
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    }
}
SwiperBodyDirective.decorators = [
    { type: Directive, args: [{ selector: '[swiperBody]' },] },
];
/** @nocollapse */
SwiperBodyDirective.ctorParameters = () => [
    { type: Renderer2, },
    { type: ElementRef, },
];
SwiperBodyDirective.propDecorators = {
    "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperTopDirective {
    /**
     * @param {?} render
     * @param {?} ele
     */
    constructor(render, ele) {
        this.render = render;
        this.ele = ele;
        this._slide = true;
    }
    /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    setHeight(val, absolute = false) {
        let /** @type {?} */ height = `calc(100% - ${val}px)`;
        this.render.setStyle(this.ele.nativeElement, 'height', height);
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    }
    /**
     * @return {?}
     */
    show() {
        this.render.addClass(this.ele.nativeElement, 'shown');
    }
}
SwiperTopDirective.decorators = [
    { type: Directive, args: [{ selector: '[swiperTop]' },] },
];
/** @nocollapse */
SwiperTopDirective.ctorParameters = () => [
    { type: Renderer2, },
    { type: ElementRef, },
];
SwiperTopDirective.propDecorators = {
    "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperBottomDirective {
    /**
     * @param {?} render
     * @param {?} ele
     */
    constructor(render, ele) {
        this.render = render;
        this.ele = ele;
        this._slide = true;
    }
    /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    setHeight(val, absolute = false) {
        let /** @type {?} */ height = `calc(100% - ${val}px)`;
        this.render.setStyle(this.ele.nativeElement, 'height', height);
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    }
    /**
     * @return {?}
     */
    show() {
        this.render.addClass(this.ele.nativeElement, 'shown');
    }
}
SwiperBottomDirective.decorators = [
    { type: Directive, args: [{ selector: '[swiperBottom]' },] },
];
/** @nocollapse */
SwiperBottomDirective.ctorParameters = () => [
    { type: Renderer2, },
    { type: ElementRef, },
];
SwiperBottomDirective.propDecorators = {
    "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperVComponent {
    /**
     * @param {?} el
     * @param {?} DEF
     * @param {?} loader
     * @param {?} render
     * @param {?} cd
     */
    constructor(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._vertical = true;
        this._absolute = true;
        this.init = new EventEmitter();
        this.slideChange = new EventEmitter();
        this.onEnd = new EventEmitter();
        this.slideIndex = 0;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set offset(val) {
        if (val) {
            this._offset = val;
            this.changeEleStyle();
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set absolute(val) {
        this._absolute = val;
        this.changeEleStyle();
    }
    /**
     * @return {?}
     */
    get absolute() {
        return this._absolute;
    }
    /**
     * @return {?}
     */
    changeEleStyle() {
        this.body && this.body.setHeight(this._offset, this._absolute);
        this.top && this.top.setHeight(this._offset, this._absolute);
        this.bottom && this.bottom.setHeight(this._offset, this._absolute);
    }
    /**
     * @return {?}
     */
    initOptions() {
        this.options = Object.assign({}, this.DEF.options, this.options);
    }
    /**
     * @param {?} index
     * @return {?}
     */
    slideTo(index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    }
    /**
     * @return {?}
     */
    getSlideIndex() {
        if (this.top) {
            this.slideIndex = 1;
        }
    }
    /**
     * @return {?}
     */
    _init() {
        this.destroy();
        this.getSlideIndex();
        this.options = Object.assign({
            initialSlide: 1,
            slideToClickedSlide: false,
            loop: false,
            direction: 'vertical',
            observer: true,
            observeParents: true,
            on: {
                init: () => {
                    this.bottom && this.bottom.show();
                    this.top && this.top.show();
                },
                transitionEnd: () => {
                    this.slideChange.emit(this.swiper);
                    this.onEnd.emit(this.swiper);
                }
            }
        }, this.options);
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
    }
    /**
     * @return {?}
     */
    destroy() {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.options)
            this.initOptions();
    }
    /**
     * @return {?}
     */
    __init() {
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(res => {
                this._init();
            });
        }
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.__init();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this._init();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
SwiperVComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper-v',
                template: `<div class="swiper-wrapper">
    <ng-content></ng-content>
</div>`,
                styles: [``],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
SwiperVComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: SwiperConfig, },
    { type: LoaderService, },
    { type: Renderer2, },
    { type: ChangeDetectorRef, },
];
SwiperVComponent.propDecorators = {
    "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
    "_vertical": [{ type: HostBinding, args: ['class.swiper-container-vertical',] },],
    "body": [{ type: ContentChild, args: [SwiperBodyDirective,] },],
    "top": [{ type: ContentChild, args: [SwiperTopDirective,] },],
    "bottom": [{ type: ContentChild, args: [SwiperBottomDirective,] },],
    "offset": [{ type: Input },],
    "absolute": [{ type: Input },],
    "options": [{ type: Input },],
    "init": [{ type: Output },],
    "slideChange": [{ type: Output },],
    "onEnd": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperScrollComponent {
    /**
     * @param {?} el
     * @param {?} DEF
     * @param {?} loader
     * @param {?} render
     * @param {?} cd
     */
    constructor(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._horizontal = true;
        this.items = [];
        this.init = new EventEmitter();
        this.up = new EventEmitter();
        this.down = new EventEmitter();
        this.up$ = new Subject$1();
        this.down$ = new Subject$1();
        this.slideIndex = 0;
        this.down$.subscribe(res => {
            this.refresh.html('加载完毕');
            setTimeout(() => {
                this.swiper.touchEventsData.isTouched = true;
                this.swiper.allowTouchMove = true;
                this.swiper.params.virtualTranslate = false;
                this.refresh.html('下拉刷新');
                this.swiper.setTranslate(0);
            }, 600);
        });
        this.up$.subscribe(res => {
            this.loadmore.html('加载完毕');
            this.swiper.allowTouchMove = true;
            this.swiper.params.virtualTranslate = false;
            this.loadmore.html('上拉加载');
        });
    }
    /**
     * @return {?}
     */
    initOptions() {
        this.options = Object.assign({}, this.DEF.options, this.options);
    }
    /**
     * @param {?} index
     * @return {?}
     */
    slideTo(index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    setItems(val) {
        if (val) {
            this.items = val;
            this.cd.detectChanges();
        }
    }
    /**
     * @return {?}
     */
    _init() {
        this.destroy();
        let /** @type {?} */ that = this;
        this.options = Object.assign({}, this.options, {
            speed: 300,
            slidesPerView: 'auto',
            freeMode: true,
            direction: 'vertical',
            observer: true,
            observeParents: true,
            freeModeMomentumBounce: true,
            freeModeMomentum: true,
            on: {
                touchStart: () => {
                    that.refresh.html('松开刷新');
                },
                touchMove: function () {
                    that.refresh.html('松开刷新');
                },
                reachEnd: function () {
                    if (this.isDown != 'up') {
                        that.swiper.allowTouchMove = false;
                        that.swiper.params.virtualTranslate = true;
                        that.isDown = 'up';
                        that.up.emit(that.up$);
                    }
                },
                touchEnd: function () {
                    if (this.isDown != 'down' || this.isDown != 'up') {
                        that.refresh.html('加载完毕');
                        that.loadmore.html('没有更多了');
                    }
                    if (this.isDown != 'down') {
                        if (this.translate > 80) {
                            this.setTransition(this.params.seed);
                            this.setTranslate(80);
                            that.swiper.touchEventsData.isTouched = false;
                            that.swiper.allowTouchMove = false;
                            that.refresh.html('<i class="weui-loading"></i>刷新中...');
                            that.isDown = 'down';
                            that.down.emit(that.down$);
                        }
                    }
                }
            }
        });
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
        this.refresh = this.swiper.$el.find('.refresh');
        this.loadmore = this.swiper.$el.find('.loadmore');
    }
    /**
     * @return {?}
     */
    destroy() {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.options)
            this.initOptions();
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.__init();
    }
    /**
     * @return {?}
     */
    __init() {
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(res => {
                this._init();
            });
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this.__init();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
SwiperScrollComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper-scroll',
                template: `<div class="swiper-wrapper">
    <div class="refresh">下拉刷新</div>
    <div class="swiper-slide" *ngFor="let item of items">
        <ng-container *ngTemplateOutlet="_ref;context: {$implicit: item}"></ng-container>
    </div>
    <div class="swiper-slide loadmore">上拉加载</div>
</div>
<ng-content></ng-content>`,
                styles: [``],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
SwiperScrollComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: SwiperConfig, },
    { type: LoaderService, },
    { type: Renderer2, },
    { type: ChangeDetectorRef, },
];
SwiperScrollComponent.propDecorators = {
    "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
    "_horizontal": [{ type: HostBinding, args: ['class.swiper-container-horizontal',] },],
    "_ref": [{ type: ContentChild, args: [TemplateRef,] },],
    "options": [{ type: Input },],
    "init": [{ type: Output },],
    "up": [{ type: Output },],
    "down": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperLayoutComponent {
    constructor() {
        this.offset = 240;
        this.open = new EventEmitter();
        this.init = new EventEmitter();
        this.onOpen$ = new Subject$1();
        this.open$ = new Subject$1();
        this.onOpen$.subscribe(res => {
            this.open.emit(res);
        });
        this.open$.subscribe(res => {
            if (res === 'center') {
                this.toCenter();
            }
            if (res === 'body') {
                this.toBody();
            }
            if (res === 'left') {
                this.toLeft();
            }
            if (res === 'right') {
                this.toRight();
            }
            if (res === 'top') {
                this.toTop();
            }
            if (res === 'bottom') {
                this.toBottom();
            }
        });
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.init.emit(this.open$);
    }
    /**
     * @return {?}
     */
    update() {
        this.hSwiper && this.hSwiper.update();
        this.vSwiper && this.vSwiper.update();
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onVInit(e) {
        if (e) {
            this.vSwiper = e;
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onHInit(e) {
        if (e) {
            this.hSwiper = e;
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onHEnd(e) {
        this.hSwiper = e;
        if (e) {
            if (e.isEnd) {
                this.open$.next('right');
            }
            else if (e.isBeginning) {
                this.open$.next('left');
            }
            else {
                this.open$.next('center');
            }
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onVEnd(e) {
        this.vSwiper = e;
        if (e) {
            if (e.isEnd) {
                this.open$.next('bottom');
            }
            else if (e.isBeginning) {
                this.open$.next('top');
            }
            else {
                this.open$.next('body');
            }
        }
    }
    /**
     * @return {?}
     */
    toMain() {
        if (!this.isHCenter()) {
            this.toCenter();
        }
        if (!this.isVCenter()) {
            this.toBody();
        }
    }
    /**
     * @return {?}
     */
    isHCenter() {
        if (this.hSwiper.isBeginning || this.hSwiper.isEnd) {
            return false;
        }
        return true;
    }
    /**
     * @return {?}
     */
    isVCenter() {
        if (this.vSwiper.isBeginning || this.vSwiper.isEnd) {
            return false;
        }
        return true;
    }
    /**
     * @return {?}
     */
    toCenter() {
        this.hSwiper.slideTo(1, 300, false);
    }
    /**
     * @return {?}
     */
    toLeft() {
        this.hSwiper.slideTo(0, 300, false);
    }
    /**
     * @return {?}
     */
    toRight() {
        this.hSwiper.slideTo(2, 300, false);
    }
    /**
     * @return {?}
     */
    toBody() {
        this.vSwiper.slideTo(1, 300, false);
    }
    /**
     * @return {?}
     */
    toTop() {
        this.vSwiper.slideTo(0, 300, false);
    }
    /**
     * @return {?}
     */
    toBottom() {
        this.vSwiper.slideTo(2, 300, false);
    }
}
SwiperLayoutComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper-layout',
                template: `<swiper-h [offset]="offset" (init)="onHInit($event)" (onEnd)="onHEnd($event)">
    <div swiperLeft>
        <ng-content select="[left]"></ng-content>
    </div>
    <div swiperCenter>
        <swiper-v (init)="onVInit($event)" [offset]="offset" (onEnd)="onVEnd($event)">
            <div swiperTop>
                <ng-content select="[top]"></ng-content>
            </div>
            <div swiperBody>
                <ng-content></ng-content>
            </div>
            <div swiperBottom>
                <ng-content select="[bottom]"></ng-content>
            </div>
        </swiper-v>
    </div>
    <div swiperRight>
        <ng-content select="[right]"></ng-content>
    </div>
</swiper-h>`,
                styles: [``],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
SwiperLayoutComponent.ctorParameters = () => [];
SwiperLayoutComponent.propDecorators = {
    "offset": [{ type: Input },],
    "open": [{ type: Output },],
    "init": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperWrapComponent {
    /**
     * @param {?} el
     * @param {?} DEF
     * @param {?} loader
     * @param {?} render
     * @param {?} cd
     */
    constructor(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._vertical = true;
        this._absolute = true;
        this.init = new EventEmitter();
        this.slideChange = new EventEmitter();
        this.onEnd = new EventEmitter();
        this.slideIndex = 0;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set offset(val) {
        if (val) {
            this._offset = val;
            this.changeEleStyle();
        }
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set absolute(val) {
        this._absolute = val;
        this.changeEleStyle();
    }
    /**
     * @return {?}
     */
    get absolute() {
        return this._absolute;
    }
    /**
     * @return {?}
     */
    changeEleStyle() {
    }
    /**
     * @return {?}
     */
    initOptions() {
        this.options = Object.assign({}, this.DEF.options, this.options);
    }
    /**
     * @param {?} index
     * @return {?}
     */
    slideTo(index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    }
    /**
     * @return {?}
     */
    _init() {
        this.destroy();
        this.options = Object.assign({
            direction: 'vertical',
            slidesPerView: 'auto',
            freeMode: true,
            scrollbar: {
                el: '.swiper-scrollbar',
            },
            mousewheel: true,
        }, this.options);
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
    }
    /**
     * @return {?}
     */
    destroy() {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.options)
            this.initOptions();
    }
    /**
     * @return {?}
     */
    __init() {
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(res => {
                this._init();
            });
        }
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.__init();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this._init();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
SwiperWrapComponent.decorators = [
    { type: Component, args: [{
                selector: 'swiper-wrap',
                template: `<div class="swiper-wrapper">
    <div class="swiper-slide">
        <ng-content></ng-content>
    </div>
</div>`,
                styles: [``],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
SwiperWrapComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: SwiperConfig, },
    { type: LoaderService, },
    { type: Renderer2, },
    { type: ChangeDetectorRef, },
];
SwiperWrapComponent.propDecorators = {
    "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
    "_vertical": [{ type: HostBinding, args: ['class.swiper-container-vertical',] },],
    "offset": [{ type: Input },],
    "absolute": [{ type: Input },],
    "options": [{ type: Input },],
    "init": [{ type: Output },],
    "slideChange": [{ type: Output },],
    "onEnd": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class SwiperModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: SwiperModule,
            providers: [
                {
                    provide: SwiperConfig,
                    useClass: SwiperConfig
                }
            ]
        };
    }
}
SwiperModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    LoaderModule.forRoot({
                        root: './assets/meepo.libs/'
                    }),
                    EventModule.forRoot()
                ],
                exports: [
                    SwiperComponent,
                    SwiperTabsComponent,
                    SwiperHComponent,
                    SwiperMenuCenterDirective,
                    SwiperMenuLeftDirective,
                    SwiperMenuRightDirective,
                    SwiperVComponent,
                    SwiperBodyDirective,
                    SwiperBottomDirective,
                    SwiperTopDirective,
                    SwiperScrollComponent,
                    SwiperLayoutComponent,
                    SwiperWrapComponent
                ],
                declarations: [
                    SwiperComponent,
                    SwiperTabsComponent,
                    SwiperHComponent,
                    SwiperMenuCenterDirective,
                    SwiperMenuLeftDirective,
                    SwiperMenuRightDirective,
                    SwiperVComponent,
                    SwiperBodyDirective,
                    SwiperBottomDirective,
                    SwiperTopDirective,
                    SwiperScrollComponent,
                    SwiperLayoutComponent,
                    SwiperWrapComponent
                ],
                providers: [],
            },] },
];
/** @nocollapse */
SwiperModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { SwiperModule, SwiperComponent, SwiperConfig, SwiperHComponent, SwiperVComponent, SwiperScrollComponent, SwiperLayoutComponent, SwiperWrapComponent, SwiperMenuCenterDirective as ɵb, SwiperMenuLeftDirective as ɵc, SwiperMenuRightDirective as ɵd, SwiperTabsComponent as ɵa, SwiperBodyDirective as ɵe, SwiperBottomDirective as ɵg, SwiperTopDirective as ɵf };
//# sourceMappingURL=meepo.js.map
