import { ChangeDetectionStrategy, ChangeDetectorRef, Component, ContentChild, Directive, ElementRef, EventEmitter, HostBinding, HostListener, Injectable, Input, NgModule, Output, Renderer2, TemplateRef, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { __assign } from 'tslib';
import { LoaderModule, LoaderService } from 'meepo-loader';
import { Subject as Subject$1 } from 'rxjs/Subject';
import { EventModule } from 'meepo-event';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperConfig = (function () {
    function SwiperConfig() {
        this.options = {};
    }
    SwiperConfig.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    SwiperConfig.ctorParameters = function () { return []; };
    return SwiperConfig;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperComponent = (function () {
    function SwiperComponent(el, DEF, loader, render, cd) {
        var _this = this;
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this.items = [];
        // 监听改变
        this.slideChange = new EventEmitter();
        this.slideChangeTransitionStart = new EventEmitter();
        this.slideChangeTransitionEnd = new EventEmitter();
        this.sliderMove = new EventEmitter();
        this.reachBeginning = new EventEmitter();
        this.reachEnd = new EventEmitter();
        this.slideNextTransitionStart = new EventEmitter();
        this.slideNextTransitionEnd = new EventEmitter();
        this.slidePrevTransitionStart = new EventEmitter();
        this.slidePrevTransitionEnd = new EventEmitter();
        this.init = new EventEmitter();
        this.onClick = new EventEmitter();
        this.onTap = new EventEmitter();
        this.doubleTap = new EventEmitter();
        this.progress = new EventEmitter();
        this.touchStart = new EventEmitter();
        this.touchMove = new EventEmitter();
        this.touchEnd = new EventEmitter();
        this.realIndex = new EventEmitter();
        this.down = new EventEmitter();
        this.up = new EventEmitter();
        this.auto = true;
        this.down$ = new Subject$1();
        this.up$ = new Subject$1();
        this.isDown = '';
        this.down$.subscribe(function (res) {
            _this.refresh.html('加载完毕');
            setTimeout(function () {
                _this.swiper.touchEventsData.isTouched = true;
                _this.swiper.allowTouchMove = true;
                _this.swiper.params.virtualTranslate = false;
                _this.swiper.setTranslate(0);
            }, 600);
        });
        this.up$.subscribe(function (res) {
            _this.loadmore.html('加载完毕');
            setTimeout(function () {
                _this.swiper.allowTouchMove = true;
                _this.swiper.params.virtualTranslate = false;
                _this.swiper.setTranslate(0);
            }, 600);
        });
    }
    Object.defineProperty(SwiperComponent.prototype, "options", {
        get: /**
         * @return {?}
         */
        function () {
            return this._options;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._options = val;
            if (this._options.direction === 'vertical') {
                this.vertical = 'vertical';
            }
            else {
                this.horizontal = 'horizontal';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SwiperComponent.prototype, "horizontal", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.render.removeClass(this.el.nativeElement, 'swiper-container-vertical');
            this.render.addClass(this.el.nativeElement, 'swiper-container-horizontal');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SwiperComponent.prototype, "vertical", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.render.removeClass(this.el.nativeElement, 'swiper-container-horizontal');
            this.render.addClass(this.el.nativeElement, 'swiper-container-vertical');
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    SwiperComponent.prototype.initOptions = /**
     * @return {?}
     */
    function () {
        this.options = Object.assign({}, this.DEF.options, this.options);
    };
    /**
     * @param {?} index
     * @param {?=} slideToOption
     * @return {?}
     */
    SwiperComponent.prototype.slideTo = /**
     * @param {?} index
     * @param {?=} slideToOption
     * @return {?}
     */
    function (index, slideToOption) {
        this.slideToOption = slideToOption;
        if (index < 0) { }
        else {
            this.swiper.slideTo(index, 600, false);
        }
    };
    /**
     * @param {?=} reinit
     * @return {?}
     */
    SwiperComponent.prototype._init = /**
     * @param {?=} reinit
     * @return {?}
     */
    function (reinit) {
        var _this = this;
        if (reinit === void 0) { reinit = false; }
        var /** @type {?} */ that = this;
        if (this.auto || reinit) {
            this.destroy();
            this.options = __assign({
                speed: 300,
                slidesPerView: 'auto',
                freeMode: true,
                direction: 'vertical',
                setWrapperSize: true,
                scrollbar: {
                    el: '.swiper-scrollbar',
                },
                on: {
                    slideChange: function () {
                        _this.slideChange.emit(_this.swiper);
                    },
                    slideChangeTransitionStart: function () {
                        _this.slideChangeTransitionStart.emit(_this.swiper);
                    },
                    slideChangeTransitionEnd: function () {
                        _this.slideChangeTransitionEnd.emit(_this.swiper);
                    },
                    sliderMove: function () {
                        _this.sliderMove.emit(_this.swiper);
                    },
                    reachBeginning: function () {
                        _this.reachBeginning.emit(_this.swiper);
                    },
                    reachEnd: function () {
                        _this.reachEnd.emit(_this.swiper);
                    },
                    slideNextTransitionStart: function () {
                        _this.slideNextTransitionStart.emit(_this.swiper);
                    },
                    slideNextTransitionEnd: function () {
                        _this.slideNextTransitionEnd.emit(_this.swiper);
                    },
                    slidePrevTransitionStart: function () {
                        _this.slidePrevTransitionStart.emit(_this.swiper);
                    },
                    slidePrevTransitionEnd: function () {
                        _this.slidePrevTransitionEnd.emit(_this.swiper);
                    },
                    init: function () {
                        _this.init.emit(_this.swiper);
                    },
                    click: function () {
                        _this.onClick.emit(_this.swiper);
                    },
                    tap: function () {
                        _this.onTap.emit(_this.swiper);
                    },
                    doubleTap: function () {
                        _this.doubleTap.emit(_this.swiper);
                    },
                    progress: function () {
                        _this.progress.emit(_this.swiper);
                    },
                    touchStart: function () {
                        _this.touchStart.emit(_this.swiper);
                    },
                    touchMove: function () {
                        that.touchMove.emit(this.swiper);
                    },
                    touchEnd: function () {
                        if (_this.isDown === 'down') {
                            _this.refresh.html('<i class="weui-loading"></i>刷新中...');
                            _this.down.emit(_this.down$);
                        }
                        if (_this.isDown === 'up') {
                            _this.loadmore.html('<i class="weui-loading"></i>加载中...');
                            _this.up.emit(_this.up$);
                        }
                        _this.touchEnd.emit(that.swiper);
                    },
                    momentumBounce: function () {
                        this.allowTouchMove = true;
                        this.params.virtualTranslate = false;
                    }
                }
            }, this.options);
            this.swiper = new Swiper(this.el.nativeElement, this.options);
            this.init.next(this.swiper);
        }
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.initOptions();
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.__init();
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.__init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(function (res) {
                _this._init();
            });
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwiperComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this._init();
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    SwiperComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper',
                    template: "<div class=\"swiper-wrapper\">\n    <div class=\"swiper-slide\" [attr.data-hash]=\"item.link\" *ngFor=\"let item of items\">\n        <ng-container *ngTemplateOutlet=\"_ref;context: {$implicit: item}\"></ng-container>\n    </div>\n</div>\n<ng-content></ng-content>",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    SwiperComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: SwiperConfig, },
        { type: LoaderService, },
        { type: Renderer2, },
        { type: ChangeDetectorRef, },
    ]; };
    SwiperComponent.propDecorators = {
        "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
        "_ref": [{ type: ContentChild, args: [TemplateRef,] },],
        "options": [{ type: Input },],
        "horizontal": [{ type: Input },],
        "vertical": [{ type: Input },],
        "items": [{ type: Input },],
        "slideChange": [{ type: Output },],
        "slideChangeTransitionStart": [{ type: Output },],
        "slideChangeTransitionEnd": [{ type: Output },],
        "sliderMove": [{ type: Output },],
        "reachBeginning": [{ type: Output },],
        "reachEnd": [{ type: Output },],
        "slideNextTransitionStart": [{ type: Output },],
        "slideNextTransitionEnd": [{ type: Output },],
        "slidePrevTransitionStart": [{ type: Output },],
        "slidePrevTransitionEnd": [{ type: Output },],
        "init": [{ type: Output },],
        "onClick": [{ type: Output },],
        "onTap": [{ type: Output },],
        "doubleTap": [{ type: Output },],
        "progress": [{ type: Output },],
        "touchStart": [{ type: Output },],
        "touchMove": [{ type: Output },],
        "touchEnd": [{ type: Output },],
        "realIndex": [{ type: Output },],
        "down": [{ type: Output },],
        "up": [{ type: Output },],
        "auto": [{ type: Input },],
    };
    return SwiperComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperTabsComponent = (function () {
    function SwiperTabsComponent() {
        this.tabs = [];
        this.footerOptions = {
            loop: false,
            preventLinksPropagation: true,
            controller: {
                control: [],
                inverse: true,
                by: 'slide',
            },
            initialSlide: 0,
            centeredSlides: true
        };
        this.mainOptions = {
            loop: false,
            controller: {
                control: [],
                inverse: true,
                by: 'slide',
            }
        };
        this.from = 'footer';
    }
    /**
     * @return {?}
     */
    SwiperTabsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { };
    /**
     * @return {?}
     */
    SwiperTabsComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ height = this.header.nativeElement.clientHeight;
        this.mainHeight = "calc( 100% - " + height + "px)";
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperTabsComponent.prototype.initMain = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e) {
            this.mainCtrl = e;
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperTabsComponent.prototype.initFooter = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e) {
            this.footerCtrl = e;
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperTabsComponent.prototype.touchStartFooter = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.from = 'footer';
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperTabsComponent.prototype.touchStartMain = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.from = 'main';
    };
    // 底部菜单改变
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperTabsComponent.prototype.doFooterItem = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e) {
            if (this.from === 'footer') {
                this.mainCtrl.slideTo(e.activeIndex);
            }
        }
    };
    // 主体改变
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperTabsComponent.prototype.doMainItem = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e) {
            if (this.from === 'main') {
                this.footerCtrl.slideTo(e.activeIndex);
            }
        }
    };
    SwiperTabsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper-tabs',
                    template: "<div #header class=\"header-advs\">\n    <div class=\"header-navs\">\n        <div class=\"header-navs-item\">\n            <span>\u5168\u90E8</span>\n        </div>\n        <swiper [items]=\"tabs\" (init)=\"initFooter($event)\" (touchStart)=\"touchStartFooter($event)\" (slideChange)=\"doFooterItem($event)\"\n            [options]=\"footerOptions\">\n            <ng-template let-item>\n                <p>{{item.title}}</p>\n            </ng-template>\n        </swiper>\n        <div class=\"header-navs-content\"></div>\n    </div>\n</div>\n<div class=\"main\" [style.height]=\"mainHeight\">\n    <swiper [items]=\"tabs\" [options]=\"mainOptions\" (touchStart)=\"touchStartMain($event)\" (init)=\"initMain($event)\" (slideChange)=\"doMainItem($event)\">\n        <ng-template let-item>\n            <ng-container *ngTemplateOutlet=\"_ref;context: {$implicit: item}\"></ng-container>\n        </ng-template>\n    </swiper>\n</div>\n",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    SwiperTabsComponent.ctorParameters = function () { return []; };
    SwiperTabsComponent.propDecorators = {
        "header": [{ type: ViewChild, args: ['header',] },],
        "_ref": [{ type: ContentChild, args: [TemplateRef,] },],
        "tabs": [{ type: Input },],
    };
    return SwiperTabsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperMenuCenterDirective = (function () {
    function SwiperMenuCenterDirective() {
        this._slide = true;
        this.click$ = new Subject$1();
    }
    /**
     * @return {?}
     */
    SwiperMenuCenterDirective.prototype.onClick = /**
     * @return {?}
     */
    function () {
        this.click$.next();
    };
    /**
     * @param {?} call
     * @return {?}
     */
    SwiperMenuCenterDirective.prototype.clickBack = /**
     * @param {?} call
     * @return {?}
     */
    function (call) {
        return this.click$.subscribe(function (res) {
            call(res);
        });
    };
    SwiperMenuCenterDirective.decorators = [
        { type: Directive, args: [{ selector: '[swiperCenter]' },] },
    ];
    /** @nocollapse */
    SwiperMenuCenterDirective.ctorParameters = function () { return []; };
    SwiperMenuCenterDirective.propDecorators = {
        "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
        "onClick": [{ type: HostListener, args: ['click', ['$event'],] },],
    };
    return SwiperMenuCenterDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperMenuLeftDirective = (function () {
    function SwiperMenuLeftDirective(ele, render) {
        this.ele = ele;
        this.render = render;
        this._slide = true;
    }
    /**
     * @return {?}
     */
    SwiperMenuLeftDirective.prototype.show = /**
     * @return {?}
     */
    function () {
        this.render.addClass(this.ele.nativeElement, 'shown');
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    };
    /**
     * @param {?} val
     * @return {?}
     */
    SwiperMenuLeftDirective.prototype.setWidth = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.render.setStyle(this.ele.nativeElement, 'width', val);
    };
    SwiperMenuLeftDirective.decorators = [
        { type: Directive, args: [{ selector: '[swiperLeft]' },] },
    ];
    /** @nocollapse */
    SwiperMenuLeftDirective.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    SwiperMenuLeftDirective.propDecorators = {
        "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
    };
    return SwiperMenuLeftDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperMenuRightDirective = (function () {
    function SwiperMenuRightDirective(ele, render) {
        this.ele = ele;
        this.render = render;
        this._slide = true;
    }
    /**
     * @return {?}
     */
    SwiperMenuRightDirective.prototype.show = /**
     * @return {?}
     */
    function () {
        this.render.addClass(this.ele.nativeElement, 'shown');
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    };
    /**
     * @param {?} val
     * @return {?}
     */
    SwiperMenuRightDirective.prototype.setWidth = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.render.setStyle(this.ele.nativeElement, 'width', val);
    };
    SwiperMenuRightDirective.decorators = [
        { type: Directive, args: [{ selector: '[swiperRight]' },] },
    ];
    /** @nocollapse */
    SwiperMenuRightDirective.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    SwiperMenuRightDirective.propDecorators = {
        "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
    };
    return SwiperMenuRightDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperHComponent = (function () {
    function SwiperHComponent(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._horizontal = true;
        this.init = new EventEmitter();
        this.slideChange = new EventEmitter();
        this.onEnd = new EventEmitter();
        this.slideIndex = 0;
    }
    Object.defineProperty(SwiperHComponent.prototype, "offset", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            if (typeof val === 'string') {
                val = parseInt(val);
            }
            if (typeof val === 'number') {
                val = val + "px";
                this.left && this.left.setWidth(val);
                this.right && this.right.setWidth(val);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SwiperHComponent.prototype, "width", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.left && this.left.setWidth(val);
            this.right && this.right.setWidth(val);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.initOptions = /**
     * @return {?}
     */
    function () {
        this.options = Object.assign({}, this.DEF.options, this.options);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    SwiperHComponent.prototype.slideTo = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.getSlideIndex = /**
     * @return {?}
     */
    function () {
        if (this.left) {
            this.slideIndex = 1;
        }
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype._init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.destroy();
        this.getSlideIndex();
        this.options = __assign({
            initialSlide: 1,
            slidesPerView: 'auto',
            resistanceRatio: 0,
            slideToClickedSlide: true,
            loop: false,
            observer: true,
            observeParents: true,
            on: {
                init: function () {
                    _this.left && _this.left.show();
                    _this.right && _this.right.show();
                },
                transitionEnd: function () {
                    _this.slideChange.emit(_this.swiper);
                    _this.onEnd.emit(_this.swiper);
                }
            }
        }, this.options);
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.initOptions();
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.__init();
        if (this.center) {
            this.center.clickBack(function (res) {
                _this.swiper.slideTo(_this.slideIndex, 300);
            });
        }
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.__init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(function (res) {
                _this._init();
            });
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwiperHComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this.__init();
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperHComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    SwiperHComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper-h',
                    template: "<div class=\"swiper-wrapper\">\n    <ng-content></ng-content>\n</div>",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    SwiperHComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: SwiperConfig, },
        { type: LoaderService, },
        { type: Renderer2, },
        { type: ChangeDetectorRef, },
    ]; };
    SwiperHComponent.propDecorators = {
        "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
        "_horizontal": [{ type: HostBinding, args: ['class.swiper-container-horizontal',] },],
        "center": [{ type: ContentChild, args: [SwiperMenuCenterDirective,] },],
        "left": [{ type: ContentChild, args: [SwiperMenuLeftDirective,] },],
        "right": [{ type: ContentChild, args: [SwiperMenuRightDirective,] },],
        "offset": [{ type: Input },],
        "width": [{ type: Input },],
        "options": [{ type: Input },],
        "init": [{ type: Output },],
        "slideChange": [{ type: Output },],
        "onEnd": [{ type: Output },],
    };
    return SwiperHComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperBodyDirective = (function () {
    function SwiperBodyDirective(render, ele) {
        this.render = render;
        this.ele = ele;
        this._slide = true;
    }
    /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    SwiperBodyDirective.prototype.setHeight = /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    function (val, absolute) {
        if (absolute === void 0) { absolute = false; }
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    };
    SwiperBodyDirective.decorators = [
        { type: Directive, args: [{ selector: '[swiperBody]' },] },
    ];
    /** @nocollapse */
    SwiperBodyDirective.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    SwiperBodyDirective.propDecorators = {
        "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
    };
    return SwiperBodyDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperTopDirective = (function () {
    function SwiperTopDirective(render, ele) {
        this.render = render;
        this.ele = ele;
        this._slide = true;
    }
    /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    SwiperTopDirective.prototype.setHeight = /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    function (val, absolute) {
        if (absolute === void 0) { absolute = false; }
        var /** @type {?} */ height = "calc(100% - " + val + "px)";
        this.render.setStyle(this.ele.nativeElement, 'height', height);
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    };
    /**
     * @return {?}
     */
    SwiperTopDirective.prototype.show = /**
     * @return {?}
     */
    function () {
        this.render.addClass(this.ele.nativeElement, 'shown');
    };
    SwiperTopDirective.decorators = [
        { type: Directive, args: [{ selector: '[swiperTop]' },] },
    ];
    /** @nocollapse */
    SwiperTopDirective.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    SwiperTopDirective.propDecorators = {
        "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
    };
    return SwiperTopDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperBottomDirective = (function () {
    function SwiperBottomDirective(render, ele) {
        this.render = render;
        this.ele = ele;
        this._slide = true;
    }
    /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    SwiperBottomDirective.prototype.setHeight = /**
     * @param {?} val
     * @param {?=} absolute
     * @return {?}
     */
    function (val, absolute) {
        if (absolute === void 0) { absolute = false; }
        var /** @type {?} */ height = "calc(100% - " + val + "px)";
        this.render.setStyle(this.ele.nativeElement, 'height', height);
        this.render.setStyle(this.ele.nativeElement, 'transition', '.3s');
    };
    /**
     * @return {?}
     */
    SwiperBottomDirective.prototype.show = /**
     * @return {?}
     */
    function () {
        this.render.addClass(this.ele.nativeElement, 'shown');
    };
    SwiperBottomDirective.decorators = [
        { type: Directive, args: [{ selector: '[swiperBottom]' },] },
    ];
    /** @nocollapse */
    SwiperBottomDirective.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ElementRef, },
    ]; };
    SwiperBottomDirective.propDecorators = {
        "_slide": [{ type: HostBinding, args: ['class.swiper-slide',] },],
    };
    return SwiperBottomDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperVComponent = (function () {
    function SwiperVComponent(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._vertical = true;
        this._absolute = true;
        this.init = new EventEmitter();
        this.slideChange = new EventEmitter();
        this.onEnd = new EventEmitter();
        this.slideIndex = 0;
    }
    Object.defineProperty(SwiperVComponent.prototype, "offset", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            if (val) {
                this._offset = val;
                this.changeEleStyle();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SwiperVComponent.prototype, "absolute", {
        get: /**
         * @return {?}
         */
        function () {
            return this._absolute;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._absolute = val;
            this.changeEleStyle();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.changeEleStyle = /**
     * @return {?}
     */
    function () {
        this.body && this.body.setHeight(this._offset, this._absolute);
        this.top && this.top.setHeight(this._offset, this._absolute);
        this.bottom && this.bottom.setHeight(this._offset, this._absolute);
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.initOptions = /**
     * @return {?}
     */
    function () {
        this.options = Object.assign({}, this.DEF.options, this.options);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    SwiperVComponent.prototype.slideTo = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.getSlideIndex = /**
     * @return {?}
     */
    function () {
        if (this.top) {
            this.slideIndex = 1;
        }
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype._init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.destroy();
        this.getSlideIndex();
        this.options = __assign({
            initialSlide: 1,
            slideToClickedSlide: false,
            loop: false,
            direction: 'vertical',
            observer: true,
            observeParents: true,
            on: {
                init: function () {
                    _this.bottom && _this.bottom.show();
                    _this.top && _this.top.show();
                },
                transitionEnd: function () {
                    _this.slideChange.emit(_this.swiper);
                    _this.onEnd.emit(_this.swiper);
                }
            }
        }, this.options);
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.initOptions();
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.__init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(function (res) {
                _this._init();
            });
        }
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.__init();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwiperVComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this._init();
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperVComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    SwiperVComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper-v',
                    template: "<div class=\"swiper-wrapper\">\n    <ng-content></ng-content>\n</div>",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    SwiperVComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: SwiperConfig, },
        { type: LoaderService, },
        { type: Renderer2, },
        { type: ChangeDetectorRef, },
    ]; };
    SwiperVComponent.propDecorators = {
        "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
        "_vertical": [{ type: HostBinding, args: ['class.swiper-container-vertical',] },],
        "body": [{ type: ContentChild, args: [SwiperBodyDirective,] },],
        "top": [{ type: ContentChild, args: [SwiperTopDirective,] },],
        "bottom": [{ type: ContentChild, args: [SwiperBottomDirective,] },],
        "offset": [{ type: Input },],
        "absolute": [{ type: Input },],
        "options": [{ type: Input },],
        "init": [{ type: Output },],
        "slideChange": [{ type: Output },],
        "onEnd": [{ type: Output },],
    };
    return SwiperVComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperScrollComponent = (function () {
    function SwiperScrollComponent(el, DEF, loader, render, cd) {
        var _this = this;
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._horizontal = true;
        this.items = [];
        this.init = new EventEmitter();
        this.up = new EventEmitter();
        this.down = new EventEmitter();
        this.up$ = new Subject$1();
        this.down$ = new Subject$1();
        this.slideIndex = 0;
        this.down$.subscribe(function (res) {
            _this.refresh.html('加载完毕');
            setTimeout(function () {
                _this.swiper.touchEventsData.isTouched = true;
                _this.swiper.allowTouchMove = true;
                _this.swiper.params.virtualTranslate = false;
                _this.refresh.html('下拉刷新');
                _this.swiper.setTranslate(0);
            }, 600);
        });
        this.up$.subscribe(function (res) {
            _this.loadmore.html('加载完毕');
            _this.swiper.allowTouchMove = true;
            _this.swiper.params.virtualTranslate = false;
            _this.loadmore.html('上拉加载');
        });
    }
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype.initOptions = /**
     * @return {?}
     */
    function () {
        this.options = Object.assign({}, this.DEF.options, this.options);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    SwiperScrollComponent.prototype.slideTo = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    };
    /**
     * @param {?} val
     * @return {?}
     */
    SwiperScrollComponent.prototype.setItems = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (val) {
            this.items = val;
            this.cd.detectChanges();
        }
    };
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype._init = /**
     * @return {?}
     */
    function () {
        this.destroy();
        var /** @type {?} */ that = this;
        this.options = __assign({}, this.options, {
            speed: 300,
            slidesPerView: 'auto',
            freeMode: true,
            direction: 'vertical',
            observer: true,
            observeParents: true,
            freeModeMomentumBounce: true,
            freeModeMomentum: true,
            on: {
                touchStart: function () {
                    that.refresh.html('松开刷新');
                },
                touchMove: function () {
                    that.refresh.html('松开刷新');
                },
                reachEnd: function () {
                    if (this.isDown != 'up') {
                        that.swiper.allowTouchMove = false;
                        that.swiper.params.virtualTranslate = true;
                        that.isDown = 'up';
                        that.up.emit(that.up$);
                    }
                },
                touchEnd: function () {
                    if (this.isDown != 'down' || this.isDown != 'up') {
                        that.refresh.html('加载完毕');
                        that.loadmore.html('没有更多了');
                    }
                    if (this.isDown != 'down') {
                        if (this.translate > 80) {
                            this.setTransition(this.params.seed);
                            this.setTranslate(80);
                            that.swiper.touchEventsData.isTouched = false;
                            that.swiper.allowTouchMove = false;
                            that.refresh.html('<i class="weui-loading"></i>刷新中...');
                            that.isDown = 'down';
                            that.down.emit(that.down$);
                        }
                    }
                }
            }
        });
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
        this.refresh = this.swiper.$el.find('.refresh');
        this.loadmore = this.swiper.$el.find('.loadmore');
    };
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    };
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.initOptions();
    };
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.__init();
    };
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype.__init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(function (res) {
                _this._init();
            });
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwiperScrollComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this.__init();
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperScrollComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    SwiperScrollComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper-scroll',
                    template: "<div class=\"swiper-wrapper\">\n    <div class=\"refresh\">\u4E0B\u62C9\u5237\u65B0</div>\n    <div class=\"swiper-slide\" *ngFor=\"let item of items\">\n        <ng-container *ngTemplateOutlet=\"_ref;context: {$implicit: item}\"></ng-container>\n    </div>\n    <div class=\"swiper-slide loadmore\">\u4E0A\u62C9\u52A0\u8F7D</div>\n</div>\n<ng-content></ng-content>",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    SwiperScrollComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: SwiperConfig, },
        { type: LoaderService, },
        { type: Renderer2, },
        { type: ChangeDetectorRef, },
    ]; };
    SwiperScrollComponent.propDecorators = {
        "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
        "_horizontal": [{ type: HostBinding, args: ['class.swiper-container-horizontal',] },],
        "_ref": [{ type: ContentChild, args: [TemplateRef,] },],
        "options": [{ type: Input },],
        "init": [{ type: Output },],
        "up": [{ type: Output },],
        "down": [{ type: Output },],
    };
    return SwiperScrollComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperLayoutComponent = (function () {
    function SwiperLayoutComponent() {
        var _this = this;
        this.offset = 240;
        this.open = new EventEmitter();
        this.init = new EventEmitter();
        this.onOpen$ = new Subject$1();
        this.open$ = new Subject$1();
        this.onOpen$.subscribe(function (res) {
            _this.open.emit(res);
        });
        this.open$.subscribe(function (res) {
            if (res === 'center') {
                _this.toCenter();
            }
            if (res === 'body') {
                _this.toBody();
            }
            if (res === 'left') {
                _this.toLeft();
            }
            if (res === 'right') {
                _this.toRight();
            }
            if (res === 'top') {
                _this.toTop();
            }
            if (res === 'bottom') {
                _this.toBottom();
            }
        });
    }
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.init.emit(this.open$);
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.update = /**
     * @return {?}
     */
    function () {
        this.hSwiper && this.hSwiper.update();
        this.vSwiper && this.vSwiper.update();
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperLayoutComponent.prototype.onVInit = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e) {
            this.vSwiper = e;
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperLayoutComponent.prototype.onHInit = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e) {
            this.hSwiper = e;
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperLayoutComponent.prototype.onHEnd = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.hSwiper = e;
        if (e) {
            if (e.isEnd) {
                this.open$.next('right');
            }
            else if (e.isBeginning) {
                this.open$.next('left');
            }
            else {
                this.open$.next('center');
            }
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SwiperLayoutComponent.prototype.onVEnd = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.vSwiper = e;
        if (e) {
            if (e.isEnd) {
                this.open$.next('bottom');
            }
            else if (e.isBeginning) {
                this.open$.next('top');
            }
            else {
                this.open$.next('body');
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toMain = /**
     * @return {?}
     */
    function () {
        if (!this.isHCenter()) {
            this.toCenter();
        }
        if (!this.isVCenter()) {
            this.toBody();
        }
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.isHCenter = /**
     * @return {?}
     */
    function () {
        if (this.hSwiper.isBeginning || this.hSwiper.isEnd) {
            return false;
        }
        return true;
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.isVCenter = /**
     * @return {?}
     */
    function () {
        if (this.vSwiper.isBeginning || this.vSwiper.isEnd) {
            return false;
        }
        return true;
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toCenter = /**
     * @return {?}
     */
    function () {
        this.hSwiper.slideTo(1, 300, false);
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toLeft = /**
     * @return {?}
     */
    function () {
        this.hSwiper.slideTo(0, 300, false);
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toRight = /**
     * @return {?}
     */
    function () {
        this.hSwiper.slideTo(2, 300, false);
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toBody = /**
     * @return {?}
     */
    function () {
        this.vSwiper.slideTo(1, 300, false);
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toTop = /**
     * @return {?}
     */
    function () {
        this.vSwiper.slideTo(0, 300, false);
    };
    /**
     * @return {?}
     */
    SwiperLayoutComponent.prototype.toBottom = /**
     * @return {?}
     */
    function () {
        this.vSwiper.slideTo(2, 300, false);
    };
    SwiperLayoutComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper-layout',
                    template: "<swiper-h [offset]=\"offset\" (init)=\"onHInit($event)\" (onEnd)=\"onHEnd($event)\">\n    <div swiperLeft>\n        <ng-content select=\"[left]\"></ng-content>\n    </div>\n    <div swiperCenter>\n        <swiper-v (init)=\"onVInit($event)\" [offset]=\"offset\" (onEnd)=\"onVEnd($event)\">\n            <div swiperTop>\n                <ng-content select=\"[top]\"></ng-content>\n            </div>\n            <div swiperBody>\n                <ng-content></ng-content>\n            </div>\n            <div swiperBottom>\n                <ng-content select=\"[bottom]\"></ng-content>\n            </div>\n        </swiper-v>\n    </div>\n    <div swiperRight>\n        <ng-content select=\"[right]\"></ng-content>\n    </div>\n</swiper-h>",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    SwiperLayoutComponent.ctorParameters = function () { return []; };
    SwiperLayoutComponent.propDecorators = {
        "offset": [{ type: Input },],
        "open": [{ type: Output },],
        "init": [{ type: Output },],
    };
    return SwiperLayoutComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperWrapComponent = (function () {
    function SwiperWrapComponent(el, DEF, loader, render, cd) {
        this.el = el;
        this.DEF = DEF;
        this.loader = loader;
        this.render = render;
        this.cd = cd;
        this._container = true;
        this._vertical = true;
        this._absolute = true;
        this.init = new EventEmitter();
        this.slideChange = new EventEmitter();
        this.onEnd = new EventEmitter();
        this.slideIndex = 0;
    }
    Object.defineProperty(SwiperWrapComponent.prototype, "offset", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            if (val) {
                this._offset = val;
                this.changeEleStyle();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SwiperWrapComponent.prototype, "absolute", {
        get: /**
         * @return {?}
         */
        function () {
            return this._absolute;
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._absolute = val;
            this.changeEleStyle();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.changeEleStyle = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.initOptions = /**
     * @return {?}
     */
    function () {
        this.options = Object.assign({}, this.DEF.options, this.options);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    SwiperWrapComponent.prototype.slideTo = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        if (this.swiper) {
            this.swiper.slideTo(index, 300, false);
        }
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype._init = /**
     * @return {?}
     */
    function () {
        this.destroy();
        this.options = __assign({
            direction: 'vertical',
            slidesPerView: 'auto',
            freeMode: true,
            scrollbar: {
                el: '.swiper-scrollbar',
            },
            mousewheel: true,
        }, this.options);
        this.swiper = new Swiper(this.el.nativeElement, this.options);
        this.init.emit(this.swiper);
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this.swiper) {
            this.swiper.destroy(true, false);
            this.swiper = null;
        }
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.options)
            this.initOptions();
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.__init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (window['Swiper']) {
            this._init();
        }
        else {
            this.loader.importLocals(['./swiper/js/swiper.min.js']).subscribe(function (res) {
                _this._init();
            });
        }
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.__init();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwiperWrapComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if ('options' in changes) {
            this.initOptions();
            if (!changes['options'].firstChange) {
                this._init();
            }
        }
    };
    /**
     * @return {?}
     */
    SwiperWrapComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    SwiperWrapComponent.decorators = [
        { type: Component, args: [{
                    selector: 'swiper-wrap',
                    template: "<div class=\"swiper-wrapper\">\n    <div class=\"swiper-slide\">\n        <ng-content></ng-content>\n    </div>\n</div>",
                    styles: [""],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    SwiperWrapComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: SwiperConfig, },
        { type: LoaderService, },
        { type: Renderer2, },
        { type: ChangeDetectorRef, },
    ]; };
    SwiperWrapComponent.propDecorators = {
        "_container": [{ type: HostBinding, args: ['class.swiper-container',] },],
        "_vertical": [{ type: HostBinding, args: ['class.swiper-container-vertical',] },],
        "offset": [{ type: Input },],
        "absolute": [{ type: Input },],
        "options": [{ type: Input },],
        "init": [{ type: Output },],
        "slideChange": [{ type: Output },],
        "onEnd": [{ type: Output },],
    };
    return SwiperWrapComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwiperModule = (function () {
    function SwiperModule() {
    }
    /**
     * @return {?}
     */
    SwiperModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: SwiperModule,
            providers: [
                {
                    provide: SwiperConfig,
                    useClass: SwiperConfig
                }
            ]
        };
    };
    SwiperModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        LoaderModule.forRoot({
                            root: './assets/meepo.libs/'
                        }),
                        EventModule.forRoot()
                    ],
                    exports: [
                        SwiperComponent,
                        SwiperTabsComponent,
                        SwiperHComponent,
                        SwiperMenuCenterDirective,
                        SwiperMenuLeftDirective,
                        SwiperMenuRightDirective,
                        SwiperVComponent,
                        SwiperBodyDirective,
                        SwiperBottomDirective,
                        SwiperTopDirective,
                        SwiperScrollComponent,
                        SwiperLayoutComponent,
                        SwiperWrapComponent
                    ],
                    declarations: [
                        SwiperComponent,
                        SwiperTabsComponent,
                        SwiperHComponent,
                        SwiperMenuCenterDirective,
                        SwiperMenuLeftDirective,
                        SwiperMenuRightDirective,
                        SwiperVComponent,
                        SwiperBodyDirective,
                        SwiperBottomDirective,
                        SwiperTopDirective,
                        SwiperScrollComponent,
                        SwiperLayoutComponent,
                        SwiperWrapComponent
                    ],
                    providers: [],
                },] },
    ];
    /** @nocollapse */
    SwiperModule.ctorParameters = function () { return []; };
    return SwiperModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { SwiperModule, SwiperComponent, SwiperConfig, SwiperHComponent, SwiperVComponent, SwiperScrollComponent, SwiperLayoutComponent, SwiperWrapComponent, SwiperMenuCenterDirective as ɵb, SwiperMenuLeftDirective as ɵc, SwiperMenuRightDirective as ɵd, SwiperTabsComponent as ɵa, SwiperBodyDirective as ɵe, SwiperBottomDirective as ɵg, SwiperTopDirective as ɵf };
//# sourceMappingURL=meepo.js.map
