import { OnInit, SimpleChanges, EventEmitter, ElementRef, Renderer2, ChangeDetectorRef, AfterContentInit } from '@angular/core';
import { SwiperConfig } from '../swiper/swiper.config';
import { LoaderService } from 'meepo-loader';
import { SwiperMenuCenterDirective } from './swiper-h.center';
import { SwiperMenuLeftDirective } from './swiper-h.left';
import { SwiperMenuRightDirective } from './swiper-h.right';
export declare class SwiperHComponent implements OnInit, AfterContentInit {
    private el;
    private DEF;
    private loader;
    render: Renderer2;
    cd: ChangeDetectorRef;
    _container: boolean;
    _horizontal: boolean;
    center: SwiperMenuCenterDirective;
    left: SwiperMenuLeftDirective;
    right: SwiperMenuRightDirective;
    offset: any;
    width: string;
    options: any;
    init: EventEmitter<any>;
    slideChange: EventEmitter<any>;
    onEnd: EventEmitter<any>;
    /**
     * swiper 实例
     */
    swiper: any;
    constructor(el: ElementRef, DEF: SwiperConfig, loader: LoaderService, render: Renderer2, cd: ChangeDetectorRef);
    private initOptions();
    slideToOption: string;
    slideTo(index: number): void;
    slideIndex: number;
    private getSlideIndex();
    _init(): void;
    private destroy();
    ngOnInit(): void;
    ngAfterContentInit(): void;
    __init(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
}
