import { OnInit, SimpleChanges, EventEmitter, ElementRef, Renderer2, ChangeDetectorRef, AfterContentInit } from '@angular/core';
import { SwiperConfig } from '../swiper/swiper.config';
import { LoaderService } from 'meepo-loader';
import { SwiperBodyDirective } from './swiper-v.body';
import { SwiperTopDirective } from './swiper-v.top';
import { SwiperBottomDirective } from './swiper-v.bottom';
export declare class SwiperVComponent implements OnInit, AfterContentInit {
    private el;
    private DEF;
    private loader;
    render: Renderer2;
    cd: ChangeDetectorRef;
    _container: boolean;
    _vertical: boolean;
    body: SwiperBodyDirective;
    top: SwiperTopDirective;
    bottom: SwiperBottomDirective;
    _offset: any;
    offset: any;
    _absolute: boolean;
    absolute: boolean;
    options: any;
    init: EventEmitter<any>;
    slideChange: EventEmitter<any>;
    onEnd: EventEmitter<any>;
    /**
     * swiper 实例
     */
    swiper: any;
    constructor(el: ElementRef, DEF: SwiperConfig, loader: LoaderService, render: Renderer2, cd: ChangeDetectorRef);
    private changeEleStyle();
    private initOptions();
    slideToOption: string;
    slideTo(index: number): void;
    slideIndex: number;
    private getSlideIndex();
    _init(): void;
    private destroy();
    ngOnInit(): void;
    __init(): void;
    width: number;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
}
